"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.renamePropsRef = renamePropsRef;
exports.default = before;

require("core-js/modules/es6.object.assign");

var _react = _interopRequireDefault(require("react"));

var _component = _interopRequireDefault(require("./component"));

var _directive = _interopRequireDefault(require("./directive"));

var _beforeProps = _interopRequireDefault(require("./before-props"));

var _beforeAction = _interopRequireDefault(require("./before-action"));

var _beforeClass = _interopRequireDefault(require("./before-class"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ReactVueLike = _react.default._vueLike && _react.default._vueLike instanceof _react.default.Component ? _react.default._vueLike : _component.default;
var Directive = ReactVueLike.Directive || _directive.default;

function isMixinComponent(source) {
  return source && (source.__vuelikeMixin || source.prototype instanceof ReactVueLike.Mixin);
}

function isDirectiveComponent(source) {
  return source && (source.__vueLikeDirective || source === Directive);
}

function renamePropsRef(props) {
  if (props && props.ref) {
    props.$ref = props.ref;
    delete props.ref;
  }
}

function before(source, props, target, isMixin) {
  if (!isMixin) (0, _beforeClass.default)(props, ReactVueLike);
  var isReactVueLikeClass = (0, _utils.isVueLikeComponent)(source);
  var isReactVueLikeMixin = isMixin || isMixinComponent(source);
  var isDirective = isDirectiveComponent(source);
  var isReactVueLikeClasses = isReactVueLikeClass || isReactVueLikeMixin || isDirective;

  if (!isReactVueLikeClasses || isDirective && !(0, _utils.isVueLikeComponent)(props._source)) {
    if (props) {
      if (props.$slots) {
        Object.assign(props, props.$slots);
        delete props.$slots;
      }
    }
  } else {
    renamePropsRef(props);
  }

  if (!source || !source.prototype || source.__ReactVueLikeHandled) return source;
  if (!isReactVueLikeClasses || isDirective) return source;

  try {
    if (!target) target = source;

    if (isReactVueLikeClass && target.mixins) {
      target.mixins.forEach(function (m, i) {
        return before(m, props, target, true);
      });
    } // eslint-disable-next-line


    if (source.props) target = (0, _beforeProps.default)(source, target, ReactVueLike);
    (0, _beforeAction.default)(source, ReactVueLike);
    return target;
  } finally {
    Object.defineProperty(target, '__ReactVueLikeHandled', {
      writable: true,
      configurable: true,
      value: true
    });
  }
}