"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.reflect.construct");

require("core-js/modules/es6.object.set-prototype-of");

require("core-js/modules/es6.object.assign");

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _mobx = require("./mobx");

var _config = _interopRequireDefault(require("./config"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Directive = /*#__PURE__*/function (_React$Component) {
  _inherits(Directive, _React$Component);

  var _super = _createSuper(Directive);

  function Directive(props) {
    var _this;

    _classCallCheck(this, Directive);

    _this = _super.call(this, props);
    _this.state = {
      isMounted: false
    };
    return _this;
  }

  _createClass(Directive, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      (0, _utils.iterativeParent)(this, function (parent) {
        return _this2.$parent = parent;
      }, function (vm) {
        return vm._isVueLike;
      });
      if (!this.$parent) throw new Error('[ReactVueLike error]: can not find directive parent component');

      var _pending = function _pending() {
        _this2.$directives = _this2.$parent.$directives;

        _this2._call('bind');

        _this2._mountPending = function () {
          _this2._mountPending = null;
          setTimeout(function () {
            return _this2._call('inserted');
          }, 0);
        };

        _this2.setState({
          isMounted: true
        });
      };

      if (this.$parent._isWillMount) _pending();else this.$parent._mountedPending.push(_pending);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      if (this._mountPending) this._mountPending();else this._call('componentUpdated');
    }
  }, {
    key: "getSnapshotBeforeUpdate",
    value: function getSnapshotBeforeUpdate(prevProps, prevState) {
      this._call('update');

      return null;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._call('unbind');
    }
  }, {
    key: "_updateRef",
    value: function _updateRef(r) {
      var ref = this.props.$ref;

      if (ref) {
        if ((0, _utils.isFunction)(ref)) ref(r);else if ((0, _utils.isObject)(ref)) ref.current = r;
      }
    }
  }, {
    key: "_call",
    value: function _call(eventName) {
      var _this3 = this;

      var el = _reactDom.default.findDOMNode(this);

      this.props._bindings.forEach(function (binding) {
        var d = _this3.$directives[binding.name];

        if (!d) {
          if (process.env.NODE_ENV !== 'production') {
            (0, _utils.warn)("directive '".concat(binding.name, "' not be found!"));
          }

          return;
        }

        var event = d[eventName];
        if (!event) return;
        if (_config.default.enforceActions) event = (0, _mobx.action)(event);
        event.call(_this3.$parent, el, binding, _this3._reactInternalFiber);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      if (!this.state.isMounted) return null; // eslint-disable-next-line

      var _this$props = this.props,
          _source = _this$props._source,
          _bindings = _this$props._bindings,
          children = _this$props.children,
          props = _objectWithoutProperties(_this$props, ["_source", "_bindings", "children"]);

      return _react.default.createElement(_source, Object.assign(props, {
        ref: function ref(_ref) {
          return _this4._updateRef(_ref);
        }
      }), children);
    }
  }]);

  return Directive;
}(_react.default.Component);

_defineProperty(Directive, "propTypes", {
  _source: _propTypes.default.oneOfType([_propTypes.default.string.isRequired, _propTypes.default.elementType.isRequired]),
  _bindings: _propTypes.default.array.isRequired
});

Directive.__vueLikeDirective = true;
var _default = Directive;
exports.default = _default;