"use strict";

require("core-js/modules/es7.object.get-own-property-descriptors");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.array.find-index");

require("core-js/modules/es6.promise");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.map");

require("core-js/modules/es6.reflect.construct");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.object.set-prototype-of");

require("core-js/modules/es6.array.find");

require("core-js/modules/es6.object.assign");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.object.keys");

var _mobx = require("mobx");

var _config = _interopRequireDefault(require("./config"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _wrapNativeSuper(Class) { var _cache = typeof Map === "function" ? new Map() : undefined; _wrapNativeSuper = function _wrapNativeSuper(Class) { if (Class === null || !_isNativeFunction(Class)) return Class; if (typeof Class !== "function") { throw new TypeError("Super expression must either be null or a function"); } if (typeof _cache !== "undefined") { if (_cache.has(Class)) return _cache.get(Class); _cache.set(Class, Wrapper); } function Wrapper() { return _construct(Class, arguments, _getPrototypeOf(this).constructor); } Wrapper.prototype = Object.create(Class.prototype, { constructor: { value: Wrapper, enumerable: false, writable: true, configurable: true } }); return _setPrototypeOf(Wrapper, Class); }; return _wrapNativeSuper(Class); }

function _construct(Parent, args, Class) { if (_isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _isNativeFunction(fn) { return Function.toString.call(fn).indexOf("[native code]") !== -1; }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function normalizeComponentNames(comps, prefix) {
  var parentKey = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  var COMP_REGX = /^[A-Z][A-Za-z]+/;
  var ret = {};
  Object.keys(comps).forEach(function (key) {
    if (!COMP_REGX.test(key)) return;
    var comp = comps[key];

    if (!comp) {
      console.warn("component [".concat(key, "] is not exist!"));
      return;
    }

    ret["".concat(prefix).concat(parentKey).concat(key)] = comp;
    Object.assign(ret, normalizeComponentNames(comp, prefix, "".concat(parentKey).concat(key)));
  });
  return ret;
}

var PluginArray = /*#__PURE__*/function (_Array) {
  _inherits(PluginArray, _Array);

  var _super = _createSuper(PluginArray);

  function PluginArray() {
    _classCallCheck(this, PluginArray);

    return _super.apply(this, arguments);
  }

  _createClass(PluginArray, [{
    key: "get",
    value: function get(name) {
      var p = this.find(function (p) {
        return p.name === name;
      });
      return p ? p.plugin : null;
    }
  }]);

  return PluginArray;
}( /*#__PURE__*/_wrapNativeSuper(Array));

var ReactVueLike = /*#__PURE__*/function () {
  function ReactVueLike() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, ReactVueLike);

    this.isVueLike = true;
    this.options = options;
    this.plugins = new PluginArray();
    this.mixins = [];
    this.components = {};
    this.filters = {};
    this.directives = {};
    this.hocs = [];
    this.events = {
      components: {},
      app: {}
    };
    this.inherits = {};
    this.config = _objectSpread({}, _config.default);
  }

  _createClass(ReactVueLike, [{
    key: "configure",
    value: function configure() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      (0, _utils.mergeObject)(this.config, options);

      if (this.config.enforceActions !== undefined) {
        (0, _mobx.configure)({
          enforceActions: _config.default.enforceActions ? 'observed' : 'never'
        });
      }
    }
  }, {
    key: "use",
    value: function use(plugin) {
      var _this = this;

      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      if (!plugin) return; // if (!plugin.name) throw new Error('[ReactVueLike.use]plugin \'name\' can not be empty!');

      var install = (0, _utils.isFunction)(plugin) ? plugin : plugin.install ? plugin.install.bind(plugin) : null;
      if (!install) throw Error('[ReactVueLike.use]plugin need has \'install\' method!');
      var ret = install(this, options);

      var afterInstall = function afterInstall() {
        _this.plugins.push({
          name: plugin.name,
          plugin: plugin,
          options: options
        });

        return function () {
          var ret;

          var idx = _this.plugins.find(function (p) {
            return p.plugin === plugin;
          });

          if (~idx) ret = _this.plugins.splice(idx, 1);
          return ret;
        };
      };

      return ret instanceof Promise ? ret.then(function () {
        return afterInstall();
      }) : afterInstall();
    }
  }, {
    key: "mixin",
    value: function mixin(_mixin) {
      if (!_mixin) return;
      this.mixins.push(_mixin);
      return function () {
        var ret;
        var idx = this.mixins.find(function (v) {
          return v === _mixin;
        });
        if (~idx) ret = this.plugins.splice(idx, 1);
        return ret;
      };
    }
  }, {
    key: "component",
    value: function component(keyOrComponents) {
      var componentOrPrefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

      if ((0, _utils.isPlainObject)(keyOrComponents)) {
        Object.assign(this.components, normalizeComponentNames(keyOrComponents, componentOrPrefix));
        return keyOrComponents;
      }

      return this.components[keyOrComponents] = componentOrPrefix;
    }
  }, {
    key: "filter",
    value: function filter(keyOrFilters, _filter) {
      if ((0, _utils.isPlainObject)(keyOrFilters)) {
        (0, _utils.mergeObject)(this.filters, keyOrFilters);
        return keyOrFilters;
      }

      return this.filters[keyOrFilters] = _filter;
    }
  }, {
    key: "directive",
    value: function directive(keyOrDirectives, _directive) {
      if ((0, _utils.isPlainObject)(keyOrDirectives)) {
        Object.assign(this.directives, keyOrDirectives);
        return keyOrDirectives;
      }

      return this.directives[keyOrDirectives] = _directive;
    }
  }, {
    key: "_off",
    value: function _off(name, listener, events) {
      if (!name) throw new Error('[ReactVueLike]on name can not be empty!');
      var listeners = events[name];
      if (!listeners) return;
      var old;

      if (!listener) {
        old = events[name];
        events[name] = [];
        return old;
      }

      var idx = listeners.findIndex(function (v) {
        return v === listener;
      });
      if (~idx) old = listeners.splice(idx, 1);
      return old;
    }
  }, {
    key: "on",
    value: function on(name, listener, isComponent) {
      var _this2 = this;

      if (!name) throw new Error('[ReactVueLike]on name can not be empty!');
      if (!listener) throw new Error('[ReactVueLike]on listener can not be null!');
      name = (0, _utils.camelize)(name);
      var events = isComponent ? this.events.components : this.events.app;
      var listeners = events[name];
      if (!listeners) events[name] = listeners = [];
      var v = listeners.find(function (v) {
        return v === listener;
      });
      if (!v) listeners.push(listener);
      return function () {
        return _this2._off(name, listener, events);
      };
    }
  }, {
    key: "off",
    value: function off(name, listener, isComponent) {
      name = (0, _utils.camelize)(name);
      var events = isComponent ? this.events.components : this.events.app;
      return this._off(name, listener, events);
    }
  }, {
    key: "inherit",
    value: function inherit(keyOrInherits, value) {
      if (!keyOrInherits) return;

      if ((0, _utils.isPlainObject)(keyOrInherits)) {
        Object.assign(this.inherits, keyOrInherits);
        return keyOrInherits;
      }

      return this.inherits[keyOrInherits] = value;
    }
  }]);

  return ReactVueLike;
}();

var _default = ReactVueLike;
exports.default = _default;